//standard libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// User libraries
#include "BOARD.h"  //<<include BOARD.h before xc.h and plib.h unless you want lots of warnings!

// Microchip libraries
#include <xc.h>
#include <plib.h>

enum {
    BASIC, BLOCKING_DELAY, LATCH, STATE_MACHINE
};
int whichTest;

int main(void) {
    BOARD_Init();
    int button_count = 0;
    long int i;
    //    whichTest = BASIC;
    //    whichTest = BLOCKING_DELAY;
    //    whichTest = LATCH;
    whichTest = STATE_MACHINE;

    switch (whichTest) {
        case BASIC:
            printf("How many times has the button been pressed?\n");
            while (1) {
                if (BTN4) {
                    button_count++;
                };
                printf("%d times\n", button_count);
            }




        case BLOCKING_DELAY:
            printf("How many times has the button been pressed?\n");
            while (1) {
                if (BTN4) {
                    button_count++;
                };
                printf("%d times\n", button_count);

                for (i = 0; i < 8000000; i++); //do nothing for ~1 second
            }



        case LATCH:
            printf("How many times has the button been pressed?\n");
            while (1) {
                if (BTN4) {
                    button_count++;
                    while (BTN4); //wait for BTN4 to be released
                };
                printf("%d times\n", button_count);
            }



        case STATE_MACHINE:
            printf("How many times has the button been pressed?\n");

            enum { PRESSED, UNPRESSED            };
            int previousState = UNPRESSED;

            while (1) {
                if (BTN4 && (previousState == UNPRESSED)) {
                    button_count++;
                    previousState = PRESSED;
                };

                if ((!BTN4) && (previousState == PRESSED)) {
                    previousState = UNPRESSED;
                }

                //print, but only occasionally
                i++;
                if (i % BOARD_GetSysClock()/10 == 0) printf("%d times\n", button_count);
            }
    }

    return 0;
}


