#include <stdio.h>
#include <stdlib.h>
#include "BOARD.h"
#include <string.h>

#include <xc.h>
#include <plib.h>


static int button_count;

int main(void)
{
    BOARD_Init();
    int i;

    // Configure Timer 1
    OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_8, 0xFFFF);

    // Set up the timer interrupt with a priority of 4.
    INTClearFlag(INT_T1);
    INTSetVectorPriority(INT_TIMER_1_VECTOR, INT_PRIORITY_LEVEL_4);
    INTSetVectorSubPriority(INT_TIMER_1_VECTOR, INT_SUB_PRIORITY_LEVEL_0);
    INTEnable(INT_T1, INT_ENABLED);

    // start non-scary code:

    printf("How many times has the button been pressed?\n");
    while (1) {
        printf("%d times\n", button_count);

        for (i = 0; i < 8000000; i++); //do nothing for ~1 second
    };


}

void __ISR(_TIMER_1_VECTOR, IPL4AUTO) Timer1Handler(void)
{
    // Clear the interrupt flag.
    INTClearFlag(INT_T1);

    
    enum {PRESSED, UNPRESSED};
    static int previousState = UNPRESSED;


    if (BTN4 && (previousState == UNPRESSED)) {
        button_count++;
        previousState = PRESSED;
    };

    if ((!BTN4) && (previousState == PRESSED)) {
        previousState = UNPRESSED;
    }


}



